﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Web.Script.Serialization;

namespace StatisticsBoxSDK
{

    public class SbDateTime
    {
        public DateTime dateTime = new DateTime();
        public override string ToString()
        {
            return dateTime.ToString("yyyy-MM-dd HH:mm:ss");
        }
    }

    [Serializable]
    public class DeviceSettings
    {
        public string   device_name;
        public SbDateTime datetime = new SbDateTime();
        public string   ntp;
        public string   timezone;
        public string   sn;
        public string   time_error;
        public int      time_difference;
    }

    [Serializable]
    public class WebserverSettings
    {
        public int port;
        public string protocol;
    }

    [Serializable]
    public class HostnameSettings
    {
        public string hostname;
    }

    [Serializable]
    public class NetSettings
    {
        public string dhcp_key;
        public string ip_device;
        public string mask;
        public string gateway;
        public string dns;
        public string mac;
    }

    public class DeviceSettingsConverter : JavaScriptConverter
    {

        public override IEnumerable<Type> SupportedTypes
        {
            get { return new[] { typeof(DeviceSettings) }; }
        }

        public override IDictionary<string, object> Serialize(object obj, JavaScriptSerializer serializer)
        {
            throw new NotImplementedException();
        }

        public override object Deserialize(IDictionary<string, object> dictionary, Type type, JavaScriptSerializer serializer)
        {
            if (dictionary == null)
                throw new ArgumentNullException("dictionary");

            if (type == typeof(DeviceSettings))
            {
                DeviceSettings deviceSettings = new DeviceSettings();

                deviceSettings.device_name = dictionary["device_name"] as String;
                deviceSettings.sn = dictionary["sn"] as String;
                deviceSettings.ntp = dictionary["ntp"] as String;
                deviceSettings.timezone = dictionary["timezone"] as String;
                String date = dictionary["date"] as String;
                String time = dictionary["time"] as String;
                deviceSettings.time_error = dictionary["time_error"] as String;
                Object time_difference;
                dictionary.TryGetValue("time_difference", out time_difference);
                if (time_difference == null)
                    deviceSettings.time_difference = 0;
                else
                    deviceSettings.time_difference = (int)time_difference;
                deviceSettings.datetime.dateTime = DateTime.Parse(date + " " + time, CultureInfo.CreateSpecificCulture("ru-Ru"));
                return deviceSettings;
            }
            return null;
        }

    }

}
