﻿using System;
using System.Collections.Specialized;
using System.Linq;
using System.Web;

namespace StatisticsBoxSDK
{
    public class UrlCreator
    {
        private string _baseUrl;
        public UrlCreator(string baseUrl)
        {
            _baseUrl = baseUrl.TrimEnd('/') + "/";
        }

        public NameValueCollection ObjectToNvc<T>(T obj)
        {
            NameValueCollection formFields = new NameValueCollection();
            obj.GetType().GetFields()
                .ToList()
                .ForEach(pi => {
                    if (pi.GetValue(obj) != null)
                        formFields.Add(HttpUtility.UrlEncode(pi.Name), HttpUtility.UrlEncode(pi.GetValue(obj).ToString()));
                    }
                );
            return formFields;
        }

        public string NvcToQueryString(NameValueCollection nvc)
        {
            var array = (from key in nvc.AllKeys
                         from value in nvc.GetValues(key)
                         select string.Format("{0}={1}", key, value))
                .ToArray();
            return string.Join("&", array);
        }

        public string ObjectToUrl<T>(String relativePath, T obj)
        {
            relativePath = relativePath.TrimEnd('?') + "?";
            return _baseUrl + relativePath + NvcToQueryString(ObjectToNvc(obj));
        }
    }
}
